<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( 'Sorry we can\'t cater you, you tried to get in from the wrong way' );
}

register_setting( 'sharekar-settings', 'sharekar_settings', array('sanitize_callback' => 'sharekar_sanitize_options'));
add_settings_section( 'sharekar-button-style', 'Share Button Settings', 'sharekar_style_section', 'sharekar' );

register_setting( 'sharekar-webshare', 'sharekar_webshare', array('sanitize_callback' => 'sharekar_sanitize_options'));
add_settings_section( 'sharekar-webshare-options', 'Share WebShare Settings', 'sharekar_webshare_section', 'sharekar_webshare' );

function sharekar_sanitize_options($val){
	if(is_array($val)){
		return map_deep($val, 'sanitize_text_field');
	}
	
	return sanitize_text_field($val);
}

add_settings_field(
	'sharekar_enable_button',
	esc_attr__( 'Enable Share Buttons', 'sharekar' ),
	'sharekar_enable_button_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'checkbox',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'enable_sharekar',
		'label_for'    => 'sharekar_enable_button_field',
		'description'  => esc_attr__( 'Enable sharekar to make it visible to your users', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_button_position',
	esc_attr__( 'Button Position', 'sharekar' ),
	'sharekar_button_position_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'select',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'button_position',
		'label_for'    => 'sharekar_button_position_field',
		'description'  => esc_attr__( 'Select the location where you want to show the buttons', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_buttons',
	esc_attr__( 'Socials', 'sharekar' ),
	'sharekar_socials_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'checkbox',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'socials',
		'label_for'    => 'sharekar_socials_field',
		'description'  => esc_attr__( 'Select the social apps you want to provide share button for', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_button_radius',
	esc_attr__( 'Button Radius', 'sharekar' ),
	'sharekar_button_radius_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'radio',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'button_radius',
		'label_for'    => 'sharekar_button_radius_field',
		'description'  => esc_attr__( 'Select the radius of button you want to show on your website', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_enable_button_color',
	esc_attr__( 'Enable Button Color', 'sharekar' ),
	'sharekar_enable_button_color_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'color',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'enable_button_color',
		'label_for'    => 'sharekar_enable_button_color_field',
		'description'  => esc_attr__( 'Enables custom button Color', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_button_color',
	esc_attr__( 'Button Color', 'sharekar' ),
	'sharekar_button_color_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'color',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'button_color',
		'label_for'    => 'sharekar_button_color_field',
		'description'  => esc_attr__( 'Select the color of buttons to match your theme', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_button_text',
	esc_attr__( 'Show Text', 'sharekar' ),
	'sharekar_button_text_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'checkbox',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'button_text',
		'label_for'    => 'sharekar_button_text_field',
		'description'  => esc_attr__( 'Enabling this field will show text along with the icon', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_button_style',
	esc_attr__( 'Button Style', 'sharekar' ),
	'sharekar_button_style_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'select',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'button_style',
		'label_for'    => 'sharekar_button_style_field',
		'description'  => esc_attr__( 'Different button styles which you can choose from', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_show_sharecount',
	esc_attr__( 'Show Share Count', 'sharekar' ),
	'sharekar_show_sharecount_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'checkbox',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'show_sharecount',
		'label_for'    => 'sharekar_show_sharecount_field',
		'description'  => esc_attr__( 'Shows number of share counts', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_sharecount_pos',
	esc_attr__( 'Share Count Position', 'sharekar' ),
	'sharekar_sharecount_pos_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'select',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'sharecount_pos',
		'label_for'    => 'sharekar_sharecount_pos_field',
		'description'  => esc_attr__( 'Place where share counts should be shown', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_sharecount_refresh',
	esc_attr__( 'Share Count Refresh Rate', 'sharekar' ),
	'sharekar_sharecount_refresh_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'select',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'sharecount_refresh',
		'label_for'    => 'sharekar_sharecount_refresh_field',
		'description'  => esc_attr__( 'After what time share count should be updated', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_fb_app_id',
	esc_attr__( 'Facebook App ID', 'sharekar' ),
	'sharekar_fb_app_id_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'text',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'fb_app_id',
		'label_for'    => 'sharekar_fb_app_id_field',
		'description'  => esc_attr__( 'Your Facebook App ID', 'sharekar' ),
	)
);

add_settings_field(
	'sharekar_fb_app_secret',
	esc_attr__( 'Facebook App Secret', 'sharekar' ),
	'sharekar_fb_app_secret_field',
	'sharekar',
	'sharekar-button-style',
	array(
		'type'         => 'text',
		'option_group' => 'sharekar-settings',
		'option_name'  => 'sharekar_settings',
		'name'         => 'fb_app_id',
		'label_for'    => 'sharekar_fb_app_secret_field',
		'description'  => esc_attr__( 'Your Facebook App Secret', 'sharekar' ),
	)
);


